//Brak boss map lua file

local lightsectors = {}

local maxlight = 192
local minlight = 124
local curlight = maxlight

local wtfbrakboss = nil

local function wtfslimit(num, n_min, n_max)
	if num < n_min then num = n_min
	elseif num > n_max then num = n_max end
	return num
end

addHook("NetVars",function(net)
	curlight = net(curlight)
	wtfbrakboss = net(wtfbrakboss)
	minlight = net(minlight)
	maxlight = net(maxlight)
end)

addHook("MapChange",function(mapnum)
	wtfbrakboss = nil
end)

addHook("MapLoad",function(mapnum)
	lightsectors = {}
	curlight = maxlight
	wtfbrakboss = nil
	if G_BuildMapTitle(mapnum) == "Black Core Zone 3" then
		for s in subsectors.iterate do
			local sec = s.sector
			if sec.tag != 54 and sec.tag != 40 and sec.tag != 50 then table.insert(lightsectors,sec) end
			if sec.floorpic == "ERZREDF3" or sec.floorpic == "ERZFLR06" or sec.floorpic == "ERZBLUF4" or sec.floorpic == "ERZGREYF" then sec.floorpic = "FLAT1_2"
			elseif sec.ceilingpic == "ERZREDF3" or sec.ceilingpic == "ERZFLR06" or sec.ceilingpic == "ERZBLUF4" or sec.ceilingpic == "ERZGREYF" then sec.ceilingpic = "FLAT1_2" end
			for ffl in sec.ffloors() do
				if ffl.bottompic == "ERZREDF3" or ffl.bottompic == "ERZFLR06" or ffl.bottompic == "ERZBLUF4" or ffl.bottompic == "ERZGREYF" then ffl.bottompic = "FLAT1_2"
				elseif ffl.toppic == "ERZREDF3" or ffl.toppic == "ERZFLR06" or ffl.toppic == "ERZBLUF4" or ffl.toppic == "ERZGREYF" then ffl.toppic = "FLAT1_2" end
			end
		end
		for mo in mobjs.iterate() do
			if mo.type == MT_CYBRAKDEMON then wtfbrakboss = mo; break end
		end
	end
end)

addHook("ThinkFrame",function()
	if not wtfbrakboss or not wtfbrakboss.valid then wtfbrakboss = nil; return end
	local lightlossperhit = (maxlight-minlight)/mobjinfo[MT_CYBRAKDEMON].spawnhealth
	local healthlost = mobjinfo[MT_CYBRAKDEMON].spawnhealth-wtfbrakboss.health
	curlight = wtfslimit(maxlight-(healthlost*lightlossperhit),minlight,maxlight)
	if healthlost < 2 and mobjinfo[MT_CYBRAKDEMON].spawnhealth > 1 then curlight = 1024 end
	for k,v in ipairs(lightsectors) do
		v.lightlevel = wtfslimit($1, -256, curlight)
	end
end)